#include <xc.h>
#include "epwm2.h"

#define PWM2_INITIALIZE_DUTY_VALUE    999

void EPWM2_Initialize(void)
{
    // Set the EPWM2 to the options selected in the User Interface
	
	// CCP2M P2A: active high; P2B: active high; DC2B 3; P2M halfbridge; 
	CCP2CON = 0xBC;    
	
	// CCP2ASE operating; PSS2BD low; PSS2AC low; CCP2AS disabled; 
	CCP2AS = 0x00;    
	
	// P2RSEN automatic_restart; P2DC 0; 
	PWM2CON = 0x80;    
	
	// STR2B P2B_to_CCP2M; STR2A P2A_to_CCP2M; STR2SYNC start_at_begin; 
	PSTR2CON = 0x03;    
	
	// CCPR2H 0; 
	CCPR2H = 0x00;    
	
	// CCPR2L 249; 
	CCPR2L = 0xF9;    

	// Selecting CCPTMRS
	CCPTMRSbits.C2TSEL = 0x0;
}

void EPWM2_LoadDutyValue(uint16_t dutyValue)
{
   // Writing to 8 MSBs of pwm duty cycle in CCPRL register
    CCPR2L = ((dutyValue & 0x03FC)>>2);
    
   // Writing to 2 LSBs of pwm duty cycle in CCPCON register
    CCP2CON = ((uint8_t)(CCP2CON & 0xCF) | ((dutyValue & 0x0003)<<4));
}
/**
 End of File
*/

